
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Canvas_documentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const canvas_documents = await db.canvas_documents.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        canvas_status: data.canvas_status
        ||
        null
            ,
            
        last_edited_at: data.last_edited_at
        ||
        null
            ,
            
        snapshot_uri: data.snapshot_uri
        ||
        null
            ,
            
        offline_enabled: data.offline_enabled
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await canvas_documents.setRoom( data.room || null, {
            transaction,
        });
        
        await canvas_documents.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return canvas_documents;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const canvas_documentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                canvas_status: item.canvas_status
            ||
            null
            ,
            
                last_edited_at: item.last_edited_at
            ||
            null
            ,
            
                snapshot_uri: item.snapshot_uri
            ||
            null
            ,
            
                offline_enabled: item.offline_enabled
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const canvas_documents = await db.canvas_documents.bulkCreate(canvas_documentsData, { transaction });

        // For each item created, replace relation files
        

        return canvas_documents;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const canvas_documents = await db.canvas_documents.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.canvas_status !== undefined) updatePayload.canvas_status = data.canvas_status;
        
        
        if (data.last_edited_at !== undefined) updatePayload.last_edited_at = data.last_edited_at;
        
        
        if (data.snapshot_uri !== undefined) updatePayload.snapshot_uri = data.snapshot_uri;
        
        
        if (data.offline_enabled !== undefined) updatePayload.offline_enabled = data.offline_enabled;
        
        
        updatePayload.updatedById = currentUser.id;

        await canvas_documents.update(updatePayload, {transaction});

        
        
        if (data.room !== undefined) {
            await canvas_documents.setRoom(
              
              data.room,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await canvas_documents.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return canvas_documents;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const canvas_documents = await db.canvas_documents.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of canvas_documents) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of canvas_documents) {
                await record.destroy({transaction});
            }
        });


        return canvas_documents;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const canvas_documents = await db.canvas_documents.findByPk(id, options);

        await canvas_documents.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await canvas_documents.destroy({
            transaction
        });

        return canvas_documents;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const canvas_documents = await db.canvas_documents.findOne(
            { where },
            { transaction },
        );

        if (!canvas_documents) {
            return canvas_documents;
        }

        const output = canvas_documents.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.canvas_events_canvas_document = await canvas_documents.getCanvas_events_canvas_document({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.room = await canvas_documents.getRoom({
            transaction
        });
        
        
        output.organizations = await canvas_documents.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.rooms,
        as: 'room',
        
        where: filter.room ? {
          [Op.or]: [
            { id: { [Op.in]: filter.room.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.room.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'canvas_documents',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.snapshot_uri) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'canvas_documents',
                        'snapshot_uri',
                        filter.snapshot_uri,
                    ),
                };
            }
            

            
            

            
            if (filter.last_edited_atRange) {
                const [start, end] = filter.last_edited_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_edited_at: {
                    ...where.last_edited_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_edited_at: {
                    ...where.last_edited_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.canvas_status) {
                where = {
                    ...where,
                canvas_status: filter.canvas_status,
            };
            }
            
            if (filter.offline_enabled) {
                where = {
                    ...where,
                offline_enabled: filter.offline_enabled,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.canvas_documents.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'canvas_documents',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.canvas_documents.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

